diff --git a/color.c b/color.c
index a096168603..bd7e1aed01 100644
--- a/color.c
+++ b/color.c
@@ -896,11 +896,10 @@ static int parse_color(struct Buffer *buf, struct Buffer *s, struct Buffer *err,
 
     if (MoreArgs(s))
     {
-      struct Buffer temporary;
-      memset(&temporary, 0, sizeof(struct Buffer));
+      struct Buffer temporary = {0};
       mutt_extract_token(&temporary, s, 0);
       match = atoi(temporary.data);
-      FREE(&temporary.data);
+      mutt_buffer_reinit(&temporary);
     }
 
     if (MoreArgs(s))
diff --git a/commands.c b/commands.c
index 6dcd2c6afb..ce123ab2fd 100644
--- a/commands.c
+++ b/commands.c
@@ -640,19 +640,17 @@ void mutt_shell_escape(void)
  */
 void mutt_enter_command(void)
 {
-  struct Buffer err, token;
+  struct Buffer err = {0}, token = {0};
   char buffer[LONG_STRING];
   int r;
 
   buffer[0] = '\0';
   if (mutt_get_field(":", buffer, sizeof(buffer), MUTT_COMMAND) != 0 || !buffer[0])
     return;
-  mutt_buffer_init(&err);
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
-  mutt_buffer_init(&token);
   r = mutt_parse_rc_line(buffer, &token, &err);
-  FREE(&token.data);
+  mutt_buffer_reinit(&token);
   if (err.data[0])
   {
     /* since errbuf could potentially contain printf() sequences in it,
@@ -664,7 +662,7 @@ void mutt_enter_command(void)
       mutt_error("%s", err.data);
   }
 
-  FREE(&err.data);
+  mutt_buffer_reinit(&err);
 }
 
 void mutt_display_address(struct Envelope *env)
diff --git a/envelope.c b/envelope.c
index d7ce4cfd7b..79f1bf00e7 100644
--- a/envelope.c
+++ b/envelope.c
@@ -88,7 +88,7 @@ void mutt_free_envelope(struct Envelope **p)
 
   if ((*p)->spam)
   {
-    mutt_buffer_deinit((*p)->spam);
+    mutt_buffer_reinit((*p)->spam);
     FREE(&(*p)->spam);
   }
 
@@ -161,7 +161,7 @@ void mutt_merge_envelopes(struct Envelope *base, struct Envelope **extra)
     * have better values. Use new versions regardless. */
   if (base->spam)
   {
-    mutt_buffer_deinit(base->spam);
+    mutt_buffer_reinit(base->spam);
     FREE(&base->spam);
   }
   mutt_list_free(&base->userhdrs);
diff --git a/hook.c b/hook.c
index 1ef1b74001..2486dc3761 100644
--- a/hook.c
+++ b/hook.c
@@ -64,16 +64,13 @@ int mutt_parse_hook(struct Buffer *buf, struct Buffer *s, unsigned long data,
                     struct Buffer *err)
 {
   struct Hook *ptr = NULL;
-  struct Buffer command, pattern;
+  struct Buffer command = {0}, pattern = {0};
   int rc;
   bool not = false;
   regex_t *rx = NULL;
   struct Pattern *pat = NULL;
   char path[_POSIX_PATH_MAX];
 
-  mutt_buffer_init(&pattern);
-  mutt_buffer_init(&command);
-
   if (~data & MUTT_GLOBALHOOK) /* NOT a global hook */
   {
     if (*s->dptr == '!')
@@ -131,8 +128,7 @@ int mutt_parse_hook(struct Buffer *buf, struct Buffer *s, unsigned long data,
       goto error;
     }
 
-    FREE(&pattern.data);
-    mutt_buffer_init(&pattern);
+    mutt_buffer_reinit(&pattern);
     pattern.data = mutt_str_strdup(path);
   }
 #ifdef USE_COMPRESSED
@@ -157,8 +153,7 @@ int mutt_parse_hook(struct Buffer *buf, struct Buffer *s, unsigned long data,
      */
     mutt_str_strfcpy(tmp, pattern.data, sizeof(tmp));
     mutt_check_simple(tmp, sizeof(tmp), DefaultHook);
-    FREE(&pattern.data);
-    mutt_buffer_init(&pattern);
+    mutt_buffer_reinit(&pattern);
     pattern.data = mutt_str_strdup(tmp);
   }
 
@@ -166,8 +161,7 @@ int mutt_parse_hook(struct Buffer *buf, struct Buffer *s, unsigned long data,
   {
     mutt_str_strfcpy(path, command.data, sizeof(path));
     mutt_expand_path(path, sizeof(path));
-    FREE(&command.data);
-    mutt_buffer_init(&command);
+    mutt_buffer_reinit(&command);
     command.data = mutt_str_strdup(path);
   }
 
@@ -179,7 +173,7 @@ int mutt_parse_hook(struct Buffer *buf, struct Buffer *s, unsigned long data,
       /* Ignore duplicate global hooks */
       if (mutt_str_strcmp(ptr->command, command.data) == 0)
       {
-        FREE(&command.data);
+        mutt_buffer_reinit(&command);
         return 0;
       }
     }
@@ -195,8 +189,8 @@ int mutt_parse_hook(struct Buffer *buf, struct Buffer *s, unsigned long data,
          * ignore it instead of creating a duplicate */
         if (mutt_str_strcmp(ptr->command, command.data) == 0)
         {
-          FREE(&command.data);
-          FREE(&pattern.data);
+          mutt_buffer_reinit(&command);
+          mutt_buffer_reinit(&pattern);
           return 0;
         }
       }
@@ -209,7 +203,7 @@ int mutt_parse_hook(struct Buffer *buf, struct Buffer *s, unsigned long data,
          * based upon some other information. */
         FREE(&ptr->command);
         ptr->command = command.data;
-        FREE(&pattern.data);
+        mutt_buffer_reinit(&pattern);
         return 0;
       }
     }
@@ -253,8 +247,8 @@ int mutt_parse_hook(struct Buffer *buf, struct Buffer *s, unsigned long data,
 
 error:
   if (~data & MUTT_GLOBALHOOK) /* NOT a global hook */
-    FREE(&pattern.data);
-  FREE(&command.data);
+    mutt_buffer_reinit(&pattern);
+  mutt_buffer_reinit(&command);
   return -1;
 }
 
@@ -331,14 +325,12 @@ int mutt_parse_unhook(struct Buffer *buf, struct Buffer *s, unsigned long data,
 void mutt_folder_hook(const char *path)
 {
   struct Hook *tmp = NULL;
-  struct Buffer err, token;
+  struct Buffer err = {0}, token = {0};
 
   current_hook_type = MUTT_FOLDERHOOK;
 
-  mutt_buffer_init(&err);
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
-  mutt_buffer_init(&token);
   TAILQ_FOREACH(tmp, &Hooks, entries)
   {
     if (!tmp->command)
@@ -351,19 +343,16 @@ void mutt_folder_hook(const char *path)
         if (mutt_parse_rc_line(tmp->command, &token, &err) == -1)
         {
           mutt_error("%s", err.data);
-          FREE(&token.data);
           mutt_sleep(1); /* pause a moment to let the user see the error */
-          current_hook_type = 0;
-          FREE(&err.data);
-
-          return;
+          goto end;
         }
       }
     }
   }
-  FREE(&token.data);
-  FREE(&err.data);
 
+end:
+  mutt_buffer_reinit(&token);
+  mutt_buffer_reinit(&err);
   current_hook_type = 0;
 }
 
@@ -384,16 +373,14 @@ char *mutt_find_hook(int type, const char *pat)
 
 void mutt_message_hook(struct Context *ctx, struct Header *hdr, int type)
 {
-  struct Buffer err, token;
+  struct Buffer err = {0}, token = {0};
   struct Hook *hook = NULL;
   struct PatternCache cache;
 
   current_hook_type = type;
 
-  mutt_buffer_init(&err);
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
-  mutt_buffer_init(&token);
   memset(&cache, 0, sizeof(cache));
   TAILQ_FOREACH(hook, &Hooks, entries)
   {
@@ -406,22 +393,19 @@ void mutt_message_hook(struct Context *ctx, struct Header *hdr, int type)
       {
         if (mutt_parse_rc_line(hook->command, &token, &err) == -1)
         {
-          FREE(&token.data);
           mutt_error("%s", err.data);
           mutt_sleep(1);
-          current_hook_type = 0;
-          FREE(&err.data);
-
-          return;
+          goto end;
         }
         /* Executing arbitrary commands could affect the pattern results,
          * so the cache has to be wiped */
         memset(&cache, 0, sizeof(cache));
       }
   }
-  FREE(&token.data);
-  FREE(&err.data);
 
+end:
+  mutt_buffer_reinit(&token);
+  mutt_buffer_reinit(&err);
   current_hook_type = 0;
 }
 
@@ -549,16 +533,13 @@ void mutt_account_hook(const char *url)
   static bool inhook = false;
 
   struct Hook *hook = NULL;
-  struct Buffer token;
-  struct Buffer err;
+  struct Buffer err = {0}, token = {0};
 
   if (inhook)
     return;
 
-  mutt_buffer_init(&err);
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
-  mutt_buffer_init(&token);
 
   TAILQ_FOREACH(hook, &Hooks, entries)
   {
@@ -571,34 +552,30 @@ void mutt_account_hook(const char *url)
 
       if (mutt_parse_rc_line(hook->command, &token, &err) == -1)
       {
-        FREE(&token.data);
         mutt_error("%s", err.data);
-        FREE(&err.data);
         mutt_sleep(1);
-
         inhook = false;
-        return;
+        goto end;
       }
 
       inhook = false;
     }
   }
 
-  FREE(&token.data);
-  FREE(&err.data);
+end:
+  mutt_buffer_reinit(&token);
+  mutt_buffer_reinit(&err);
 }
 #endif
 
 void mutt_timeout_hook(void)
 {
   struct Hook *hook = NULL;
-  struct Buffer token;
-  struct Buffer err;
+  struct Buffer err = {0}, token = {0};
   char buf[STRING];
 
   err.data = buf;
   err.dsize = sizeof(buf);
-  mutt_buffer_init(&token);
 
   TAILQ_FOREACH(hook, &Hooks, entries)
   {
@@ -614,7 +591,7 @@ void mutt_timeout_hook(void)
        * failed, we'll carry on with the others. */
     }
   }
-  FREE(&token.data);
+  mutt_buffer_reinit(&token);
 }
 
 /**
@@ -627,13 +604,12 @@ void mutt_timeout_hook(void)
 void mutt_startup_shutdown_hook(int type)
 {
   struct Hook *hook = NULL;
-  struct Buffer token;
-  struct Buffer err;
   char buf[STRING];
+  struct Buffer token = {0};
+  struct Buffer err = {0};
 
   err.data = buf;
   err.dsize = sizeof(buf);
-  mutt_buffer_init(&token);
 
   TAILQ_FOREACH(hook, &Hooks, entries)
   {
@@ -646,5 +622,5 @@ void mutt_startup_shutdown_hook(int type)
       mutt_sleep(1);
     }
   }
-  FREE(&token.data);
+  mutt_buffer_reinit(&token);
 }
diff --git a/imap/command.c b/imap/command.c
index 5e8eca6c94..ffc05be4db 100644
--- a/imap/command.c
+++ b/imap/command.c
@@ -483,7 +483,7 @@ static void cmd_parse_lsub(struct ImapData *idata, char *s)
 {
   char buf[STRING];
   char errstr[STRING];
-  struct Buffer err, token;
+  struct Buffer err = {0}, token = {0};
   struct Url url;
   struct ImapList list;
 
@@ -517,13 +517,11 @@ static void cmd_parse_lsub(struct ImapData *idata, char *s)
     url.user = NULL;
   url_tostring(&url, buf + 11, sizeof(buf) - 11, 0);
   mutt_str_strcat(buf, sizeof(buf), "\"");
-  mutt_buffer_init(&token);
-  mutt_buffer_init(&err);
   err.data = errstr;
   err.dsize = sizeof(errstr);
   if (mutt_parse_rc_line(buf, &token, &err))
     mutt_debug(1, "Error adding subscribed mailbox: %s\n", errstr);
-  FREE(&token.data);
+  mutt_buffer_reinit(&token);
 }
 
 /**
diff --git a/imap/imap.c b/imap/imap.c
index 0802f1fc0d..ecceaf77ef 100644
--- a/imap/imap.c
+++ b/imap/imap.c
@@ -1258,7 +1258,7 @@ int imap_exec_msgset(struct ImapData *idata, const char *pre, const char *post,
   rc = count;
 
 out:
-  mutt_buffer_deinit(&cmd);
+  mutt_buffer_reinit(&cmd);
   if (oldsort != Sort)
   {
     Sort = oldsort;
@@ -1706,7 +1706,7 @@ void imap_mboxcache_free(struct ImapData *idata)
  */
 int imap_search(struct Context *ctx, const struct Pattern *pat)
 {
-  struct Buffer buf;
+  struct Buffer buf = {0};
   struct ImapData *idata = ctx->data;
   for (int i = 0; i < ctx->msgcount; i++)
     ctx->hdrs[i]->matched = false;
@@ -1714,20 +1714,19 @@ int imap_search(struct Context *ctx, const struct Pattern *pat)
   if (!do_search(pat, 1))
     return 0;
 
-  mutt_buffer_init(&buf);
   mutt_buffer_addstr(&buf, "UID SEARCH ");
   if (compile_search(ctx, pat, &buf) < 0)
   {
-    FREE(&buf.data);
+    mutt_buffer_reinit(&buf);
     return -1;
   }
   if (imap_exec(idata, buf.data, 0) < 0)
   {
-    FREE(&buf.data);
+    mutt_buffer_reinit(&buf);
     return -1;
   }
 
-  FREE(&buf.data);
+  mutt_buffer_reinit(&buf);
   return 0;
 }
 
@@ -1744,7 +1743,7 @@ int imap_subscribe(char *path, bool subscribe)
   char buf[LONG_STRING];
   char mbox[LONG_STRING];
   char errstr[STRING];
-  struct Buffer err, token;
+  struct Buffer err = {0}, token = {0};
   struct ImapMbox mx;
 
   if (!mx_is_imap(path) || imap_parse_path(path, &mx) || !mx.mbox)
@@ -1762,14 +1761,12 @@ int imap_subscribe(char *path, bool subscribe)
 
   if (option(OPT_IMAP_CHECK_SUBSCRIBED))
   {
-    mutt_buffer_init(&token);
-    mutt_buffer_init(&err);
     err.data = errstr;
     err.dsize = sizeof(errstr);
     snprintf(mbox, sizeof(mbox), "%smailboxes \"%s\"", subscribe ? "" : "un", path);
     if (mutt_parse_rc_line(mbox, &token, &err))
       mutt_debug(1, "Error adding subscribed mailbox: %s\n", errstr);
-    FREE(&token.data);
+    mutt_buffer_reinit(&token);
   }
 
   if (subscribe)
@@ -2002,7 +1999,7 @@ int imap_fast_trash(struct Context *ctx, char *dest)
   rc = 0;
 
 out:
-  mutt_buffer_deinit(&sync_cmd);
+  mutt_buffer_reinit(&sync_cmd);
   FREE(&mx.mbox);
 
   return rc < 0 ? -1 : rc;
@@ -2193,15 +2190,14 @@ static int imap_open_mailbox(struct Context *ctx)
     else
     {
       struct ListNode *np;
-      struct Buffer flag_buffer;
-      mutt_buffer_init(&flag_buffer);
+      struct Buffer flag_buffer = {0};
       mutt_buffer_printf(&flag_buffer, "Mailbox flags: ");
       STAILQ_FOREACH(np, &idata->flags, entries)
       {
         mutt_buffer_printf(&flag_buffer, "[%s] ", np->data);
       }
       mutt_debug(3, "%s\n", flag_buffer.data);
-      FREE(&flag_buffer.data);
+      mutt_buffer_reinit(&flag_buffer);
     }
   }
 #endif
@@ -2726,7 +2722,7 @@ static int imap_commit_message_tags(struct Context *ctx, struct Header *h, char
      * continue to add new flags *
      */
     int rc = imap_exec(idata, cmd.data, 0);
-    mutt_buffer_deinit(&cmd);
+    mutt_buffer_reinit(&cmd);
     if (rc != 0)
     {
       return -1;
@@ -2744,7 +2740,7 @@ static int imap_commit_message_tags(struct Context *ctx, struct Header *h, char
     mutt_buffer_addstr(&cmd, ")");
 
     int rc = imap_exec(idata, cmd.data, 0);
-    mutt_buffer_deinit(&cmd);
+    mutt_buffer_reinit(&cmd);
    
     if (rc != 0)
     {
diff --git a/imap/message.c b/imap/message.c
index 5708dd2410..933121b1ac 100644
--- a/imap/message.c
+++ b/imap/message.c
@@ -819,7 +819,7 @@ int imap_read_headers(struct ImapData *idata, unsigned int msn_begin, unsigned i
     safe_asprintf(&cmd, "FETCH %s (UID FLAGS INTERNALDATE RFC822.SIZE %s)", b.data, hdrreq);
     imap_cmd_start(idata, cmd);
     FREE(&cmd);
-    mutt_buffer_deinit(&b);
+    mutt_buffer_reinit(&b);
 
     rc = IMAP_CMD_CONTINUE;
     for (msgno = msn_begin; rc == IMAP_CMD_CONTINUE; msgno++)
@@ -1388,7 +1388,7 @@ int imap_append_message(struct Context *ctx, struct Message *msg)
 int imap_copy_messages(struct Context *ctx, struct Header *h, char *dest, int delete)
 {
   struct ImapData *idata = NULL;
-  struct Buffer cmd, sync_cmd;
+  struct Buffer cmd = {0}, sync_cmd = {0};
   char mbox[LONG_STRING];
   char mmbox[LONG_STRING];
   char prompt[LONG_STRING];
@@ -1426,8 +1426,8 @@ int imap_copy_messages(struct Context *ctx, struct Header *h, char *dest, int de
   /* loop in case of TRYCREATE */
   do
   {
-    mutt_buffer_init(&sync_cmd);
-    mutt_buffer_init(&cmd);
+    mutt_buffer_reinit(&sync_cmd);
+    mutt_buffer_reinit(&cmd);
 
     /* Null Header* means copy tagged messages */
     if (!h)
@@ -1553,10 +1553,8 @@ int imap_copy_messages(struct Context *ctx, struct Header *h, char *dest, int de
   rc = 0;
 
 out:
-  if (cmd.data)
-    FREE(&cmd.data);
-  if (sync_cmd.data)
-    FREE(&sync_cmd.data);
+  mutt_buffer_reinit(&cmd);
+  mutt_buffer_reinit(&sync_cmd);
   FREE(&mx.mbox);
 
   return rc < 0 ? -1 : rc;
diff --git a/imap/util.c b/imap/util.c
index e4bbfe48a1..1532500979 100644
--- a/imap/util.c
+++ b/imap/util.c
@@ -637,7 +637,7 @@ void imap_free_idata(struct ImapData **idata)
   FREE(&(*idata)->capstr);
   mutt_list_free(&(*idata)->flags);
   imap_mboxcache_free(*idata);
-  mutt_buffer_deinit(&(*idata)->cmdbuf);
+  mutt_buffer_reinit(&(*idata)->cmdbuf);
   FREE(&(*idata)->buf);
   mutt_bcache_close(&(*idata)->bcache);
   FREE(&(*idata)->cmds);
diff --git a/init.c b/init.c
index cdab4f92f1..05eace1010 100644
--- a/init.c
+++ b/init.c
@@ -645,11 +645,12 @@ int mutt_extract_token(struct Buffer *dest, struct Buffer *tok, int flags)
         }
         else
         {
-          mutt_buffer_deinit(tok);
-          tok->dsize = filter_out_len + mutt_str_strlen(tok->dptr) + 1;
-          char *ptr = mutt_mem_malloc(tok->dsize);
+          size_t size = filter_out_len + mutt_str_strlen(tok->dptr) + 1;
+          char *ptr = mutt_mem_malloc(size);
           memcpy(ptr, filter_out, filter_out_len);
           strcpy(ptr + filter_out_len, tok->dptr);
+          mutt_buffer_reinit(tok);
+          tok->dsize = size;
           tok->data = tok->dptr = ptr;
         }
         FREE(&filter_out);
@@ -696,7 +697,7 @@ int mutt_extract_token(struct Buffer *dest, struct Buffer *tok, int flags)
     else
       mutt_buffer_addch(dest, ch);
   }
-  mutt_buffer_addch(dest, 0); /* terminate the string */
+  mutt_buffer_addch(dest, '\0'); /* terminate the string */
   SKIPWS(tok->dptr);
   return 0;
 }
@@ -1052,12 +1053,8 @@ static int parse_ifdef(struct Buffer *tmp, struct Buffer *s, unsigned long data,
   {
     int rc = mutt_parse_rc_line(tmp->data, &token, err);
     if (rc == -1)
-    {
       mutt_error("Error: %s", err->data);
-      FREE(&token.data);
-      return -1;
-    }
-    FREE(&token.data);
+    mutt_buffer_reinit(&token);
     return rc;
   }
   return 0;
@@ -1209,9 +1206,7 @@ static int parse_replace_list(struct Buffer *buf, struct Buffer *s,
                               unsigned long data, struct Buffer *err)
 {
   struct ReplaceList **list = (struct ReplaceList **) data;
-  struct Buffer templ;
-
-  memset(&templ, 0, sizeof(templ));
+  struct Buffer templ = {0};
 
   /* First token is a regex. */
   if (!MoreArgs(s))
@@ -1231,10 +1226,10 @@ static int parse_replace_list(struct Buffer *buf, struct Buffer *s,
 
   if (add_to_replace_list(list, buf->data, templ.data, err) != 0)
   {
-    FREE(&templ.data);
+    mutt_buffer_reinit(&templ);
     return -1;
   }
-  FREE(&templ.data);
+  mutt_buffer_reinit(&templ);
 
   return 0;
 }
@@ -1298,9 +1293,7 @@ static int parse_unsubjectrx_list(struct Buffer *buf, struct Buffer *s,
 static int parse_spam_list(struct Buffer *buf, struct Buffer *s,
                            unsigned long data, struct Buffer *err)
 {
-  struct Buffer templ;
-
-  mutt_buffer_init(&templ);
+  struct Buffer templ = {0};
 
   /* Insist on at least one parameter */
   if (!MoreArgs(s))
@@ -1326,10 +1319,10 @@ static int parse_spam_list(struct Buffer *buf, struct Buffer *s,
       /* Add to the spam list. */
       if (add_to_replace_list(&SpamList, buf->data, templ.data, err) != 0)
       {
-        FREE(&templ.data);
+        mutt_buffer_reinit(&templ);
         return -1;
       }
-      FREE(&templ.data);
+      mutt_buffer_reinit(&templ);
     }
 
     /* If not, try to remove from the nospam list. */
@@ -3124,7 +3117,6 @@ static int source_rc(const char *rcfile_path, struct Buffer *err)
 {
   FILE *f = NULL;
   int line = 0, rc = 0, conv = 0, line_rc, warnings = 0;
-  struct Buffer token;
   char *linebuf = NULL;
   char *currentline = NULL;
   char rcfile[PATH_MAX];
@@ -3178,7 +3170,7 @@ static int source_rc(const char *rcfile_path, struct Buffer *err)
     return -1;
   }
 
-  mutt_buffer_init(&token);
+  struct Buffer token = {0};
   while ((linebuf = mutt_file_read_line(linebuf, &buflen, f, &line, MUTT_CONT)) != NULL)
   {
     conv = ConfigCharset && (*ConfigCharset) && Charset;
@@ -3221,7 +3213,7 @@ static int source_rc(const char *rcfile_path, struct Buffer *err)
     if (conv)
       FREE(&currentline);
   }
-  FREE(&token.data);
+  mutt_buffer_reinit(&token);
   FREE(&linebuf);
   mutt_file_fclose(&f);
   if (pid != -1)
@@ -3305,7 +3297,7 @@ int mutt_parse_rc_line(/* const */ char *line, struct Buffer *token, struct Buff
   mutt_buffer_addstr(&expn, line);
   mutt_buffer_rewind(&expn);
 
-  *err->data = 0;
+  *err->data = '\0';
 
   SKIPWS(expn.dptr);
   while (*expn.dptr)
@@ -3338,7 +3330,7 @@ int mutt_parse_rc_line(/* const */ char *line, struct Buffer *token, struct Buff
     }
   }
 finish:
-  mutt_buffer_deinit(&expn);
+  mutt_buffer_reinit(&expn);
   return r;
 }
 
@@ -3880,10 +3872,7 @@ int mutt_query_variables(struct ListHead *queries)
 {
   char command[STRING];
 
-  struct Buffer err, token;
-
-  mutt_buffer_init(&err);
-  mutt_buffer_init(&token);
+  struct Buffer err = {0}, token = {0};
 
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
@@ -3895,16 +3884,16 @@ int mutt_query_variables(struct ListHead *queries)
     if (mutt_parse_rc_line(command, &token, &err) == -1)
     {
       fprintf(stderr, "%s\n", err.data);
-      FREE(&token.data);
-      FREE(&err.data);
+      mutt_buffer_reinit(&token);
+      mutt_buffer_reinit(&err);
 
       return 1;
     }
     printf("%s\n", err.data);
   }
 
-  FREE(&token.data);
-  FREE(&err.data);
+  mutt_buffer_reinit(&token);
+  mutt_buffer_reinit(&err);
 
   return 0;
 }
@@ -3916,10 +3905,7 @@ int mutt_dump_variables(int hide_sensitive)
 {
   char command[STRING];
 
-  struct Buffer err, token;
-
-  mutt_buffer_init(&err);
-  mutt_buffer_init(&token);
+  struct Buffer err = {0}, token = {0};
 
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
@@ -3938,42 +3924,40 @@ int mutt_dump_variables(int hide_sensitive)
     if (mutt_parse_rc_line(command, &token, &err) == -1)
     {
       fprintf(stderr, "%s\n", err.data);
-      FREE(&token.data);
-      FREE(&err.data);
+      mutt_buffer_reinit(&token);
+      mutt_buffer_reinit(&err);
 
       return 1;
     }
     printf("%s\n", err.data);
   }
 
-  FREE(&token.data);
-  FREE(&err.data);
+  mutt_buffer_reinit(&token);
+  mutt_buffer_reinit(&err);
 
   return 0;
 }
 
 static int execute_commands(struct ListHead *p)
 {
-  struct Buffer err, token;
+  struct Buffer err = {0}, token = {0};
 
-  mutt_buffer_init(&err);
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
-  mutt_buffer_init(&token);
   struct ListNode *np;
   STAILQ_FOREACH(np, p, entries)
   {
     if (mutt_parse_rc_line(np->data, &token, &err) == -1)
     {
       fprintf(stderr, _("Error in command line: %s\n"), err.data);
-      FREE(&token.data);
-      FREE(&err.data);
+      mutt_buffer_reinit(&token);
+      mutt_buffer_reinit(&err);
 
       return -1;
     }
   }
-  FREE(&token.data);
-  FREE(&err.data);
+  mutt_buffer_reinit(&token);
+  mutt_buffer_reinit(&err);
 
   return 0;
 }
@@ -4018,9 +4002,8 @@ void mutt_init(int skip_sys_rc, struct ListHead *commands)
   struct utsname utsname;
   char *p, buffer[STRING];
   int need_pause = 0;
-  struct Buffer err;
+  struct Buffer err = {0};
 
-  mutt_buffer_init(&err);
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
   err.dptr = err.data;
@@ -4190,17 +4173,15 @@ void mutt_init(int skip_sys_rc, struct ListHead *commands)
   p = getenv("REPLYTO");
   if (p)
   {
-    struct Buffer buf, token;
+    struct Buffer buf = {0}, token = {0};
 
     snprintf(buffer, sizeof(buffer), "Reply-To: %s", p);
 
-    mutt_buffer_init(&buf);
     buf.data = buf.dptr = buffer;
     buf.dsize = mutt_str_strlen(buffer);
 
-    mutt_buffer_init(&token);
     parse_my_hdr(&token, &buf, 0, &err);
-    FREE(&token.data);
+    mutt_buffer_reinit(&token);
   }
 
   p = getenv("EMAIL");
@@ -4373,7 +4354,7 @@ void mutt_init(int skip_sys_rc, struct ListHead *commands)
   }
 #endif
 
-  FREE(&err.data);
+  mutt_buffer_reinit(&err);
 }
 
 int mutt_get_hook_type(const char *name)
diff --git a/keymap.c b/keymap.c
index 29a8d8937f..f4115c8bf9 100644
--- a/keymap.c
+++ b/keymap.c
@@ -972,12 +972,10 @@ int mutt_parse_push(struct Buffer *buf, struct Buffer *s, unsigned long data,
  */
 char *parse_keymap(int *menu, struct Buffer *s, int maxmenus, int *nummenus, struct Buffer *err)
 {
-  struct Buffer buf;
+  struct Buffer buf = {0};
   int i = 0;
   char *p = NULL, *q = NULL;
 
-  mutt_buffer_init(&buf);
-
   /* menu name */
   mutt_extract_token(&buf, s, 0);
   p = buf.data;
@@ -1017,7 +1015,7 @@ char *parse_keymap(int *menu, struct Buffer *s, int maxmenus, int *nummenus, str
     mutt_str_strfcpy(err->data, _("too few arguments"), err->dsize);
   }
 error:
-  FREE(&buf.data);
+  mutt_buffer_reinit(&buf);
   return NULL;
 }
 
diff --git a/mutt/buffer.c b/mutt/buffer.c
index 33074522dd..5f113f6ec0 100644
--- a/mutt/buffer.c
+++ b/mutt/buffer.c
@@ -29,7 +29,7 @@
  * | Function             | Description
  * | :------------------- | :--------------------------------------------------
  * | mutt_buffer_init()   | Initialise a new Buffer
- * | mutt_buffer_deinit() | Release the memory allocated by a Buffer
+ * | mutt_buffer_reinit() | Release all memory and reinitialize a Buffer
  * | mutt_buffer_add()    | Add a string to a Buffer, expanding it if necessary
  * | mutt_buffer_addch()  | Add a single character to a Buffer
  * | mutt_buffer_addstr() | Add a string to a Buffer
@@ -60,12 +60,13 @@ void mutt_buffer_init(struct Buffer *buf)
 }
 
 /**
- * mutt_buffer_deinit - Release the memory allocated by a Buffer
- * @param b Buffer to release
+ * mutt_buffer_reinit - Release all memory and reinitialize a Buffer
+ * @param b Buffer to release and reinitialize
  */
-void mutt_buffer_deinit(struct Buffer *buf)
+void mutt_buffer_reinit(struct Buffer *buf)
 {
   FREE(&buf->data);
+  mutt_buffer_init(buf);
 }
 
 /**
diff --git a/mutt/buffer.h b/mutt/buffer.h
index 3aeeabcfa2..b9788fac33 100644
--- a/mutt/buffer.h
+++ b/mutt/buffer.h
@@ -39,7 +39,7 @@ struct Buffer
 #define MoreArgs(p) (*(p)->dptr && (*(p)->dptr != ';') && (*(p)->dptr != '#'))
 
 void mutt_buffer_init(struct Buffer *buf);
-void mutt_buffer_deinit(struct Buffer *buf);
+void mutt_buffer_reinit(struct Buffer *buf);
 void mutt_buffer_add(struct Buffer *buf, const char *s, size_t len);
 void mutt_buffer_addch(struct Buffer *buf, char c);
 void mutt_buffer_addstr(struct Buffer *buf, const char *s);
diff --git a/mutt_lua.c b/mutt_lua.c
index 7faa2fbd17..4c8126f484 100644
--- a/mutt_lua.c
+++ b/mutt_lua.c
@@ -60,15 +60,11 @@ static int handle_error(lua_State *l)
 static int lua_mutt_call(lua_State *l)
 {
   mutt_debug(2, " * lua_mutt_call()\n");
-  struct Buffer token, expn, err;
+  struct Buffer token = {0}, expn = {0}, err = {0};
   char buffer[LONG_STRING] = "";
   const struct Command *command = NULL;
   int rc = 0;
 
-  mutt_buffer_init(&token);
-  mutt_buffer_init(&expn);
-  mutt_buffer_init(&err);
-
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
 
@@ -108,7 +104,7 @@ static int lua_mutt_call(lua_State *l)
       rc++;
   }
 
-  FREE(&err.data);
+  mutt_buffer_reinit(&err);
 
   return rc;
 }
@@ -266,13 +262,10 @@ static int lua_mutt_get(lua_State *l)
 static int lua_mutt_enter(lua_State *l)
 {
   mutt_debug(2, " * lua_mutt_enter()\n");
-  struct Buffer token, err;
+  struct Buffer token = {0}, err = {0};
   char *buffer = mutt_str_strdup(lua_tostring(l, -1));
   int rc = 0;
 
-  mutt_buffer_init(&err);
-  mutt_buffer_init(&token);
-
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
 
@@ -290,7 +283,7 @@ static int lua_mutt_enter(lua_State *l)
   }
 
   FREE(&buffer);
-  FREE(&err.data);
+  mutt_buffer_reinit(&err);
 
   return rc;
 }
diff --git a/muttlib.c b/muttlib.c
index 88b3498c12..8a3f5db780 100644
--- a/muttlib.c
+++ b/muttlib.c
@@ -1034,9 +1034,9 @@ void mutt_expando_format(char *buf, size_t buflen, size_t col, int cols, const c
         *wptr = '\0';
       }
 
-      mutt_buffer_deinit(&srcbuf);
-      mutt_buffer_deinit(&word);
-      mutt_buffer_deinit(&command);
+      mutt_buffer_reinit(&srcbuf);
+      mutt_buffer_reinit(&word);
+      mutt_buffer_reinit(&command);
       return;
     }
   }
diff --git a/pattern.c b/pattern.c
index 185b240163..2e45322cd5 100644
--- a/pattern.c
+++ b/pattern.c
@@ -80,12 +80,11 @@ enum EatRangeError
 
 static bool eat_regex(struct Pattern *pat, struct Buffer *s, struct Buffer *err)
 {
-  struct Buffer buf;
+  struct Buffer buf = {0};
   char errmsg[STRING];
   int r;
   char *pexpr = NULL;
 
-  mutt_buffer_init(&buf);
   pexpr = s->dptr;
   if (mutt_extract_token(&buf, s, MUTT_TOKEN_PATTERN | MUTT_TOKEN_COMMENT) != 0 || !buf.data)
   {
@@ -102,12 +101,12 @@ static bool eat_regex(struct Pattern *pat, struct Buffer *s, struct Buffer *err)
   {
     pat->p.str = mutt_str_strdup(buf.data);
     pat->ign_case = mutt_which_case(buf.data) == REG_ICASE;
-    FREE(&buf.data);
+    mutt_buffer_reinit(&buf);
   }
   else if (pat->groupmatch)
   {
     pat->p.g = mutt_pattern_group(buf.data);
-    FREE(&buf.data);
+    mutt_buffer_reinit(&buf);
   }
   else
   {
@@ -118,11 +117,11 @@ static bool eat_regex(struct Pattern *pat, struct Buffer *s, struct Buffer *err)
     {
       regerror(r, pat->p.regex, errmsg, sizeof(errmsg));
       mutt_buffer_printf(err, "'%s': %s", buf.data, errmsg);
-      FREE(&buf.data);
+      mutt_buffer_reinit(&buf);
       FREE(&pat->p.regex);
       return false;
     }
-    FREE(&buf.data);
+    mutt_buffer_reinit(&buf);
   }
 
   return true;
@@ -401,11 +400,10 @@ static void adjust_date_range(struct tm *min, struct tm *max)
 
 static bool eat_date(struct Pattern *pat, struct Buffer *s, struct Buffer *err)
 {
-  struct Buffer buffer;
+  struct Buffer buffer = {0};
   struct tm min, max;
   char *pexpr = NULL;
 
-  mutt_buffer_init(&buffer);
   pexpr = s->dptr;
   if (mutt_extract_token(&buffer, s, MUTT_TOKEN_COMMENT | MUTT_TOKEN_PATTERN) != 0 ||
       !buffer.data)
@@ -486,7 +484,7 @@ static bool eat_date(struct Pattern *pat, struct Buffer *s, struct Buffer *err)
       pc = get_date(pc, &min, err);
       if (!pc)
       {
-        FREE(&buffer.data);
+        mutt_buffer_reinit(&buffer);
         return false;
       }
       haveMin = true;
@@ -521,7 +519,7 @@ static bool eat_date(struct Pattern *pat, struct Buffer *s, struct Buffer *err)
 
       if (!parse_date_range(pc, &min, &max, haveMin, &baseMin, err))
       { /* bail out on any parsing error */
-        FREE(&buffer.data);
+        mutt_buffer_reinit(&buffer);
         return false;
       }
     }
@@ -533,7 +531,7 @@ static bool eat_date(struct Pattern *pat, struct Buffer *s, struct Buffer *err)
   pat->min = mutt_date_make_time(&min, 1);
   pat->max = mutt_date_make_time(&max, 1);
 
-  FREE(&buffer.data);
+  mutt_buffer_reinit(&buffer);
 
   return true;
 }
@@ -1145,9 +1143,8 @@ struct Pattern *mutt_pattern_comp(/* const */ char *s, int flags, struct Buffer
   const struct PatternFlags *entry = NULL;
   char *p = NULL;
   char *buf = NULL;
-  struct Buffer ps;
+  struct Buffer ps = {0};
 
-  mutt_buffer_init(&ps);
   ps.dptr = s;
   ps.dsize = mutt_str_strlen(s);
 
@@ -1923,7 +1920,7 @@ int mutt_pattern_func(int op, char *prompt)
 {
   struct Pattern *pat = NULL;
   char buf[LONG_STRING] = "", *simple = NULL;
-  struct Buffer err;
+  struct Buffer err = {0};
   struct Progress progress;
 
   mutt_str_strfcpy(buf, NONULL(Context->pattern), sizeof(buf));
@@ -1936,7 +1933,6 @@ int mutt_pattern_func(int op, char *prompt)
   simple = mutt_str_strdup(buf);
   mutt_check_simple(buf, sizeof(buf), NONULL(SimpleSearch));
 
-  mutt_buffer_init(&err);
   err.dsize = STRING;
   err.data = mutt_mem_malloc(err.dsize);
   pat = mutt_pattern_comp(buf, MUTT_FULL_MSG, &err);
@@ -1944,7 +1940,7 @@ int mutt_pattern_func(int op, char *prompt)
   {
     FREE(&simple);
     mutt_error("%s", err.data);
-    FREE(&err.data);
+    mutt_buffer_reinit(&err);
     return -1;
   }
 
@@ -2031,7 +2027,7 @@ int mutt_pattern_func(int op, char *prompt)
   }
   FREE(&simple);
   mutt_pattern_free(&pat);
-  FREE(&err.data);
+  mutt_buffer_reinit(&err);
 
   return 0;
 }
@@ -2067,8 +2063,7 @@ int mutt_search_command(int cur, int op)
 
     if (!SearchPattern || (mutt_str_strcmp(temp, LastSearchExpn) != 0))
     {
-      struct Buffer err;
-      mutt_buffer_init(&err);
+      struct Buffer err = {0};
       set_option(OPT_SEARCH_INVALID);
       mutt_str_strfcpy(LastSearch, buf, sizeof(LastSearch));
       mutt_message(_("Compiling search pattern..."));
@@ -2079,7 +2074,7 @@ int mutt_search_command(int cur, int op)
       if (!SearchPattern)
       {
         mutt_error("%s", err.data);
-        FREE(&err.data);
+        mutt_buffer_reinit(&err);
         LastSearch[0] = '\0';
         return -1;
       }
